/** \file utils.cpp
 * \brief \ref utils method implementation.
 *
 * This file includes the \ref utils methods implementation.
 */

#include <string.h>
#include <stdlib.h>
#include <iostream.h>

#include "utils.h"

/*++++++++++++++++++++++++++++++++++++++++++++++++
| void utils::initVect(int *, int, int)          |
|      This method is used to initializate all   |
|      positions of a vector with a given value. |
++++++++++++++++++++++++++++++++++++++++++++++++*/

void utils::initlVect(int *vector, int tam, int valor) {
    
  for(int i = 0; i < tam; i++) 
    vector[i] = valor;
    
}

void utils::initlVect(float *vector, int tam, float valor) {
    
	for(int i = 0; i < tam; i++) 
		vector[i] = valor;
    
}


/*+++++++++++++++++++++++++++++++++++++++++++++
| void utils::copyVect(int *, int *, int)     |
|      This method copies integer vector 1 to |
|      integer vector 2.                      |
+++++++++++++++++++++++++++++++++++++++++++++*/

void utils::copyVect(int *vect1, int *vect2, int tam) {

  for(int i = 0; i < tam; i++)
    vect2[i] = vect1[i];
}


/*+++++++++++++++++++++++++++++++++++++++++++++++
| void utils::copyVect(float *, float *, float) |
|      This method copies float vector 1 to     |
|      float vector 2.                          |
+++++++++++++++++++++++++++++++++++++++++++++++*/

void utils::copyVect(float *vect1, float *vect2, int tam) {

  for(int i = 0; i < tam; i++)
    vect2[i] = vect1[i];
}


/*+++++++++++++++++++++++++++++++++++++++++
| int utils::roundToInf(double)           |
|      This method rounds a double number |
|      to the inferior integer.           |
+++++++++++++++++++++++++++++++++++++++++*/

int utils::roundToInf(double number) {

  return ((int) number);
}


/*+++++++++++++++++++++++++++++++++++++++++
| int utils::roundInt(double)             |
|      This method rounds a double number |
|      to a integer.                      | 
+++++++++++++++++++++++++++++++++++++++++*/

int utils::roundInt(double number) {    
 
  return ((int) ((double) number + 0.5));
}


/*+++++++++++++++++++++++++++++++++++++++++
| int utils::roundToSup(double)           |
|      This method rounds a double number |
|      to the greater integer.            | 
+++++++++++++++++++++++++++++++++++++++++*/

int utils::roundToSup(double number) {
  
  return ((int) ((double) number + 1.0));
}


/*+++++++++++++++++++++++++++++++++++++++++
| int utils::max(int, int)                |
|      This method returns the maximum    |
|      value of the two given arguments.  |
+++++++++++++++++++++++++++++++++++++++++*/

int utils::max(int x, int y) { 
  
  if(x > y) return x;
  else      return y;
}


/*+++++++++++++++++++++++++++++++++++++++++++
| bool utils::isNumber(char *)              |
|      This method checks if the given      |
|      string is a float number.            |
+++++++++++++++++++++++++++++++++++++++++++*/

bool utils::isNumber(char *num){
  
  int tam = strlen(num);
  int flag = 1;


  for(int i = 0; i < tam; i++) {
    if(num[i] == '.' && flag)
      flag = 0;

    else if(num[i] > '9' || num[i] < '0')
      return false;
  }
  
  return true;
  
}


/*+++++++++++++++++++++++++++++++++++++++++++
| bool utils::compare(char *, char *)       |
|      This method compares the two strings |
|      given, and returns true if the two   |
|      strings are equal.                   |
+++++++++++++++++++++++++++++++++++++++++++*/

bool utils::compare(char *a, char *b){
  return(!strcmp(a,b));
}


/*++++++++++++++++++++++++++++++++++++++++++
| void utils::removeSpaces(char *, char *) |
|      This method removes spaces in the   |  
|      input string and put the result in  |
|      the output string.                  |
++++++++++++++++++++++++++++++++++++++++++*/

void utils::removeSpaces(char *in, char *out){

  unsigned int i, j = 0;
  
  
  for(i = 0; i < strlen(in); i++){
    
    if(in[i] != ' ' && in[i] != '\t'){
      out[j] = in[i];
      j++;
    }
    
  }
  
  out[j] = '\0';

}


/*++++++++++++++++++++++++++++++++++++++++++
| void utils::quicksort(float *, int, int) |
|      This method sorts the vector using  |
|      the quicksort method.               |
++++++++++++++++++++++++++++++++++++++++++*/

void utils::quicksort(float *vect, int ini, int fin) {
  float elem_div;
  int i, j;

  elem_div = vect[fin];
  i = ini - 1;
  j = fin;
  
  if (ini >= fin) return;
  
  while (1) {

    while (vect[++i] < elem_div);
    while (vect[--j] > elem_div);

    if(i < j) swap(&vect[i], &vect[j]);
    else break;
  }
   swap(&vect[i], &vect[fin]);
  
  quicksort(vect, ini, i - 1);
  quicksort(vect, i + 1, fin);
}


/*++++++++++++++++++++++++++++++++++++++++
| void utils::swap(float *, float *)     |
|      This method swaps the values in a |
|      and b.                            |
++++++++++++++++++++++++++++++++++++++++*/

void utils::swap(float *a, float *b){

  float temp;

  temp = *a;
  *a = *b;
  *b = temp;
  
}

